function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
import { Component } from 'react';
import PropTypes from 'prop-types';
import noop from '../../utils/noop';
var Base = /*#__PURE__*/function (_Component) {
  _inheritsLoose(Base, _Component);
  function Base() {
    var _this;
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _Component.call.apply(_Component, [this].concat(args)) || this;
    _defineProperty(_assertThisInitialized(_this), "onChange", function (event) {
      // TODO: Refactor conditions
      var isChecked = _this.state.isCheckbox ? !_this.state.isChecked : true;
      var checkboxValue = isChecked ? event.target.value : '';
      var value = _this.state.isCheckbox ? checkboxValue : event.target.value;
      event.persist();
      _this.setState({
        value: value,
        isChanged: true,
        isChecked: isChecked
      }, function () {
        _this.context.validateState(_this.props.name);
        (_this.props.onChange || noop)(event);
      });
    });
    _defineProperty(_assertThisInitialized(_this), "onBlur", function (event) {
      event.persist();
      _this.setState({
        isUsed: true
      }, function () {
        _this.context.validateState(_this.props.name);
        (_this.props.onBlur || noop)(event);
      });
    });
    return _this;
  }
  var _proto = Base.prototype;
  _proto.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var _this2 = this;
    if (nextProps.value !== this.props.value) {
      this.setState({
        value: nextProps.value,
        isChanged: true
      }, function () {
        _this2.context.validateState(_this2.props.name);
      });
    }
  };
  _proto.componentWillUnmount = function componentWillUnmount() {
    this.context.unregister(this);
  };
  return Base;
}(Component);
_defineProperty(Base, "contextTypes", {
  register: PropTypes.func.isRequired,
  unregister: PropTypes.func.isRequired,
  validateState: PropTypes.func.isRequired,
  components: PropTypes.objectOf(PropTypes.any),
  errors: PropTypes.objectOf(PropTypes.array)
});
Base.propTypes = process.env.NODE_ENV !== "production" ? {
  value: PropTypes.string.isRequired,
  name: PropTypes.string.isRequired,
  onChange: PropTypes.func,
  onBlur: PropTypes.func
} : {};
export default Base;