var _excluded = ["errorClassName", "className"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
var Button = /*#__PURE__*/function (_Component) {
  _inheritsLoose(Button, _Component);
  function Button() {
    return _Component.apply(this, arguments) || this;
  }
  var _proto = Button.prototype;
  _proto.render = function render() {
    var _cx;
    var _this$props = this.props,
      errorClassName = _this$props.errorClassName,
      className = _this$props.className,
      rest = _objectWithoutPropertiesLoose(_this$props, _excluded);
    var isDisabled = Object.keys(this.context.errors).length;
    return /*#__PURE__*/React.createElement("button", _extends({
      className: cx((_cx = {}, _cx[className] = !!className, _cx[errorClassName] = isDisabled && errorClassName, _cx)),
      disabled: isDisabled
    }, rest), this.props.children);
  };
  return Button;
}(Component);
_defineProperty(Button, "contextTypes", {
  errors: PropTypes.objectOf(PropTypes.array)
});
export { Button as default };
Button.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node,
  errorClassName: PropTypes.string,
  className: PropTypes.string
} : {};