"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _rules = _interopRequireDefault(require("./rules"));
var _Form = _interopRequireDefault(require("./components/Form/Form"));
var _Input = _interopRequireDefault(require("./components/Input/Input"));
var _Select = _interopRequireDefault(require("./components/Select/Select"));
var _Textarea = _interopRequireDefault(require("./components/Textarea/Textarea"));
var _Button = _interopRequireDefault(require("./components/Button/Button"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var _default = {
  rules: _rules["default"],
  components: {
    Form: _Form["default"],
    Input: _Input["default"],
    Select: _Select["default"],
    Textarea: _Textarea["default"],
    Button: _Button["default"]
  }
};
exports["default"] = _default;
module.exports = exports.default;